#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		daemon		%{name}d
#-----------------------------------------------------------------------------
Name		:	rsyslog
Version		:	8.2404.0
Release		:	17.2.0.rel%{?dist}
Summary		:	Enhanced system logging and kernel message trapping daemon

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPL-3.0-or-later AND Apache-2.0
URL		:	http://www.rsyslog.com/

Source0		:	%{name}-%{version}.tar.gz
			#https://github.com/rsyslog/rsyslog/
Source1		:	%{name}-doc-%{version}.tar.gz
			#https://www.rsyslog.com/downloads/download-v8-stable/
Source3		:	%{name}-ok_addon.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	libestr-devel
BuildRequires	:	libfastjson-devel
BuildRequires	:	python3-docutils

Requires	:	lfs-bootscripts
Requires	:	logrotate

Provides	:	syslog

Obsoletes	:	sysklogd < 1.5-11
#-----------------------------------------------------------------------------
%description
Rsyslog is an enhanced, multi-threaded syslog daemon.
It supports MySQL, syslog/TCP, RFC 3195, permitted
sender lists, filtering on any message part, and fine
grain output format control. It is compatible with
stock sysklogd and can be used as a drop-in replacement.
Rsyslog is simple to set up, with advanced features
suitable for enterprise-class, encryption-protected
syslog relay chains.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog README.md
%license COPYING*
%{_sbindir}/%{daemon}
%attr (0754,root,root) %{_sysconfdir}/rc.d/init.d/%{name}
%config(noreplace) %{_sysconfdir}/%{name}.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}.lr
%dir %{_sysconfdir}/%{name}.d/

#plugins
%{_libdir}/%{name}/fmhash.so
%{_libdir}/%{name}/fmhttp.so
%{_libdir}/%{name}/imklog.so
%{_libdir}/%{name}/immark.so
%{_libdir}/%{name}/imtcp.so
%{_libdir}/%{name}/imudp.so
%{_libdir}/%{name}/imuxsock.so
%{_libdir}/%{name}/lmnet.so
%{_libdir}/%{name}/lmnetstrms.so
%{_libdir}/%{name}/lmnsd_ptcp.so
%{_libdir}/%{name}/lmregexp.so
%{_libdir}/%{name}/lmtcpclt.so
%{_libdir}/%{name}/lmtcpsrv.so
%{_libdir}/%{name}/lmzlibw.so
%{_libdir}/%{name}/mmexternal.so
%{_libdir}/%{name}/omtesting.so
%dir %{_sharedstatedir}/%{name}
%{_defaultdocdir}/%{name}-%{version}/recover_qi.pl
%{_mandir}/man5/%{name}.conf.5.gz
%{_mandir}/man8/%{name}d.8.gz

#-----------------------------------------------------------------------------
%preun
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{name} stop > /dev/null 2>&1 || :
  %{_sbindir}/chkconfig --del %{name}
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
fi

%post
%{_sbindir}/chkconfig --add %{name}
%{_sysconfdir}/rc.d/init.d/%{name} condrestart > /dev/null 2>&1 || :

#=============================================================================
%package		doc
Summary		:	HTML documentation for '%{name}'

#-----------------------------------------------------------------------------
Requires	:	%{name}	= %{version}-%{release}

BuildArch	:	noarch
#-----------------------------------------------------------------------------
%description		doc
The package contains all html documentation
for developing applications that use '%{name}'.

#-----------------------------------------------------------------------------
%files			doc
%defattr(-,root,root,-)
%doc %{_defaultdocdir}/%{name}-%{version}/html/

#=============================================================================
%package		pgsql
Summary		:	PostgresSQL support for '%{name}'

#-----------------------------------------------------------------------------
BuildRequires	:	postgresql-server-devel

Requires	:	%{name}	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		pgsql
The '%{name}'-pgsql package contains a dynamic
shared object that will add PostgreSQL database
support to '%{name}'

#-----------------------------------------------------------------------------
%files			pgsql
%defattr(-,root,root,-)
%doc %{_defaultdocdir}/%{name}-%{version}/pgsql-createDB.sql
%{_libdir}/%{name}/ompgsql.so

#=============================================================================
%package		mysql
Summary		:	MySQL support for '%{name}'

#-----------------------------------------------------------------------------
BuildRequires	:	mariadb

Requires	:	%{name}	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		mysql
The '%{name}'-mysql package contains a dynamic
shared object that will add MySQL database
support to '%{name}'

#-----------------------------------------------------------------------------
%files			mysql
%defattr(-,root,root,-)
%doc %{_defaultdocdir}/%{name}-%{version}/mysql-createDB.sql
%{_libdir}/%{name}/ommysql.so


#=============================================================================
%package		crypto
Summary		:	Encryption support for '%{name}'

#-----------------------------------------------------------------------------
Requires	:	%{name}	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		crypto
This package contains a module providing
log file encryption and a command line tool
to process encrypted logs.

#-----------------------------------------------------------------------------
%files			crypto
%defattr(-,root,root,-)
%{_bindir}/rscryutil
%{_libdir}/%{name}/lmcry_gcry.so
%{_mandir}/man1/rscryutil.1.gz

#=============================================================================
%package		openssl
Summary		:	TLS protocol support for '%{name}' via OpenSSL library

#-----------------------------------------------------------------------------
BuildRequires	:	openssl-devel

Requires	:	%{name}	= %{version}-%{release}
Requires	:	openssl-libs

#-----------------------------------------------------------------------------
%description		openssl
The '%{name}'-openssl package contains the
'%{name}' plugins that provide the ability to
send and receive syslog messages via TCP or
RELP using TLS encryption via OpenSSL library.
For details refer to '%{name}' doc on imtcp
and omfwd modules.

#-----------------------------------------------------------------------------
%files			openssl
%defattr(-,root,root,-)
%{_libdir}/%{name}/lmnsd_ossl.so

#=============================================================================
%prep
# set up rsyslog-doc sources
%setup -q -a 1 -T -c
%{__rm} -r LICENSE README.md source build/objects.inv
%{__mv} build doc
# set up rsyslog sources
%setup -q -D

#getting osukiss addon
tar xf %{SOURCE3}

#-----------------------------------------------------------------------------
#building application
%build

autoreconf -vif
./configure						\
        --prefix=%{_prefix}				\
        --includedir=%{_includedir}/%{name}		\
	--exec-prefix=%{_exec_prefix}			\
	--libexecdir=%{_libexecdir}/%{name}		\
        --sysconfdir=%{_sysconfdir}/%{name}		\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--disable-static				\
	--disable-testbench				\
	--enable-generate-man-pages			\
	--enable-mysql					\
	--enable-openssl				\
	--enable-pgsql					\
	--enable-usertools				\
	

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}


%{__make}						\
	V=1						\
	DESTDIR=%{buildroot}				\
	install

#installing %{name} starting/stopping script
%{__mkdir_p} %{buildroot}%{_sysconfdir}/rc.d/init.d
%{__cp} 						\
	%{name}-ok_addon/%{name}.init			\
	%{buildroot}%{_sysconfdir}/rc.d/init.d/%{name}
	
#prepare the extra configuration dircectory
install -d -m 755					\
	%{buildroot}%{_sysconfdir}/%{name}.d/

#Creating working directory
install -d -m 755					\
	%{buildroot}%{_sharedstatedir}/%{name}

install -d -m 755					\
	%{buildroot}%{_defaultdocdir}/%{name}-%{version}/html

#install postgresql plugin
install -p -m 644					\
	plugins/ompgsql/createDB.sql			\
	%{buildroot}%{_defaultdocdir}/%{name}-%{version}/pgsql-createDB.sql
#install mysqll plugin
install -p -m 644					\
	plugins/ommysql/createDB.sql			\
	%{buildroot}%{_defaultdocdir}/%{name}-%{version}/mysql-createDB.sql

install -p -m 644					\
	tools/recover_qi.pl				\
	%{buildroot}%{_defaultdocdir}/%{name}-%{version}/recover_qi.pl

#installing documentation
%{__cp} -r						\
	doc/*						\
	%{buildroot}%{_defaultdocdir}/%{name}-%{version}/html

install -d -m 755 %{buildroot}%{_sysconfdir}/logrotate.d
install -p -m 644					\
	%{name}-ok_addon/%{name}.conf			\
	%{buildroot}%{_sysconfdir}/
install -p -m 644					\
	%{name}-ok_addon/%{name}.lr			\
	%{buildroot}%{_sysconfdir}/logrotate.d/


#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.la					\
	-delete

#-----------------------------------------------------------------------------
%changelog
